#ifndef __RIGID_SHAPES_BI__
#define __RIGID_SHAPES_BI__

#include "vector.bi"

type polygon_t
	clr as integer                '' color
	npoints as integer            '' number of points in the polygon
	points as integer ptr         '' pointer to as list of shp->lpoints[] indexes
	pointflags as integer ptr     '' pointer to a list of flags
	polyflags as integer          ''
	faces as line_t ptr           '' pointer to a list of line_t (one for each point on the closed polygon)
	axials as line_t ptr
end type

type polygon_list_t
	npolygons as integer            '' number of polygons in the set
	polygons as polygon_t ptr ptr   '' pointer to list of polygon pointers
end type

type shape_t
	name as string * 32             '' name assigned to shape
	plists(0 to 1) as polygon_list_t      
	npoints as integer              '' total number of points in the set
	lpoints as vector ptr           '' pointer to a list of vectors in local space
	lpointflags as integer ptr      '' pointer to a list of flags
	origin as vector                '' point origin [m, m] (temporary)
	cm as vector                    '' center of mass [m, m] (temporary)
end type

declare function Create_Shape(strName as string) as shape_t ptr
declare function Find_Shape(strName as string) as shape_t ptr
declare function Add_Shape(byval shp as shape_t ptr) as integer
declare function Add_Shape_Point(byval shp as shape_t ptr, byval x as real, byval y as real, byval flags as integer) as integer
declare function Create_Polygon() as polygon_t ptr
declare function Add_Shape_Polygon(byval shp as shape_t ptr, byval ply as polygon_t ptr) as integer
declare function Add_Polygon_Point(byval ply as polygon_t ptr, byval pntidx as integer, byval flags as integer) as integer
declare sub SetCurrentColor(r as integer, g as integer, b as integer)
declare sub Destroy_All_Shapes()

declare function GetOutlinePoly(byval shp as shape_t ptr) as polygon_t ptr
declare function GetBoxPoly(byval shp as shape_t ptr) as polygon_t ptr
declare function GetPolyCount(byval shp as shape_t ptr) as integer
declare function GetPoly(byval shp as shape_t ptr, index as integer) as polygon_t ptr

#endif
