#ifndef __RIGID_WORLD_BI__
#define __RIGID_WORLD_BI__

#include "vector.bi"

type wall_t
	aindex as integer '' Point one index
	bindex as integer '' Point two index
	ab as vector			'' unit vector of ab
	face as line_t		'' line as equation, normal and offset from origin
	clr as integer		'' color
end type

declare function Add_WallByPoints(a as vector, b as vector, byval flags as integer, dv as vector) as integer
declare sub Destroy_All_Walls()

declare Sub Create_World()
declare Sub Destroy_World()
declare function FindWorldCollision(a as vector, d as real, n as vector) as integer
declare function GetWorldForceOnPoint(a as vector, f as vector) as integer
declare function CheckIsInWorld(a as vector) as integer
declare sub DumpWorldInfo()
declare function CheckVisibility(a as vector, b as vector) as integer

extern NUM_WALLS as integer
extern walls() as wall_t ptr

extern NUM_WORLD_POINTS as integer
extern worldpoints() as vector
extern worldpointflags() as integer

#endif